---
title: Une histoire de pizzas, étape 3
template: game
---

<a href="../une-histoire-de-pizzas-3.html">Lire l’article associé</a>

<div id="app">
    <div class="board">
        <div v-for="y in size" :key="y" class="board-line">
            <div v-for="x in size" :key="x" class="board-cell">
            </div>
        </div>

        <!--
            Dans le template HTML, on change l'appel à `id` qui a été déplacé
            au sein des entités
        -->
        <div
          v-for="entity in store"
          :key="entity.id"
          :class="['board-cell-entity', entity.id]"
          :style="entityPosition(entity)"
        >
            <div v-if="entity.label" class="entity-label">
                {{ entity.label }}
            </div>
        </div>

        <!--
            On ajoute un lien qui recouvre l’ensemble de la zone de jeu et qui
            va récupérer les clics du ou de la joueuse pour ensuite modifier
            l’état du jeu.
        -->
        <a href="#" @click="onBoardClick" class="board-click-zone"></a>
    </div>
</div>

<script>
    const BOARD_SIZE = 6;

    const CSS_CELL_SIZE = 128;

    // On revoit la structure de données du store en le transformant en un
    // Array pour faciliter la manipulation des données.
    // Les anciennes clés qui servaient à identifier les entités sont déplacées
    // au sein des entités.
    let gameStore = [
        {
            id: 'meiko',
            label: 'Meiko',
            size: { width: 1, height: 1 },
            position: { x: 3, y: 2 },
        },

        {
            id: 'mozza',
            label: 'Mozzarella',
            size: { width: 1, height: 1 },
            position: { x: 1, y: 3 },
        },
        {
            id: 'tomato',
            label: 'Sauce tomate',
            size: { width: 1, height: 1 },
            position: { x: 2, y: 5 },
        },
        {
            id: 'dough',
            label: 'Pâte à pizza',
            size: { width: 1, height: 1 },
            position: { x: 5, y: 3 },
        },

        {
            id: 'oven',
            label: 'Four',
            size: { width: 2, height: 1 },
            position: { x: 1, y: 0 },
        },
        {
            id: 'hatch',
            label: 'Passe-plat',
            size: { width: 1, height: 1 },
            position: { x: 5, y: 0 },
        },
        {
            id: 'fridge',
            label: 'Frigo',
            size: { width: 2, height: 2 },
            position: { x: 0, y: 2 },
        },
        {
            id: 'workplan',
            label: 'Plan de travail',
            size: { width: 1, height: 2 },
            position: { x: 5, y: 2 },
        },
        {
            id: 'shelf',
            label: 'Étagère',
            size: { width: 4, height: 1 },
            position: { x: 2, y: 5 },
        },
    ];

    const app = new Vue({
        el: '#app',
        data: {
            size: BOARD_SIZE,
            store: gameStore,
        },

        methods: {
            entityPosition(entity) {
                if (entity.size == null || entity.position == null) {
                    return {};
                }

                return {
                    width: (entity.size.width * CSS_CELL_SIZE) + 'px',
                    height: (entity.size.height * CSS_CELL_SIZE) + 'px',
                    top: (entity.position.y * CSS_CELL_SIZE) + 'px',
                    left: (entity.position.x * CSS_CELL_SIZE) + 'px',
                };
            },

            onBoardClick(e) {
                // C'est ici qu'on connecte le tout : onBoardClick est appelé
                // quand on clique sur le lien .board-click-zone. On passe
                // l'évènement généré à un "système" qui va modifier le store
                // (ou non) en conséquence. Le store retourné est réassigné à
                // notre objet VueJS, ce qui va entrainer un rafraichissement
                // du HTML si besoin. Magique.
                this.store = onClickSystem(e, this.store);
            },
        },
    });

    // Notre premier "vrai" système. C'est une fonction qui prend un store
    // en entrée et en retourne un en sortie (modifié... ou non).
    // L'évènement qui est également passé en argument permet de déterminer
    // quelle zone du jeu a été "activée" par le ou la joueuse.
    function onClickSystem(e, store) {
        // On fait en sorte que le clic ne soit pas actionné (sinon l'écran va
        // remonter en haut de l'écran et ce sera pas agréable)
        e.preventDefault();

        // e.layerX et e.layerY donnent la position en pixels de là où l’on a
        // cliqué. Il suffit de diviser cette valeur par la taille d’une
        // cellule et d'arrondir le résultat pour savoir sur quelle cellule on
        // a cliqué... enfin presque, on retranche encore "1" parce que notre
        // tableau commence à l'indice "0".
        // Exemple : si la cellule à l’indice 0 fait 10px et que l’on clique
        // sur le pixel "10", le calcul 10/10 est égal à 1 ; il faut donc
        // retrancher encore 1 pour retrouver notre indice "0".
        // Et si vous avez rien compris c'est pas dramatique, en plus j'ai pas
        // fait comme ça dans le jeu de base :)
        const x = Math.ceil(e.layerX / CSS_CELL_SIZE) - 1;
        const y = Math.ceil(e.layerY / CSS_CELL_SIZE) - 1;

        // On change la position de Meiko pour correspondre à l'endroit visé à
        // l'aide de la fonction écrite juste en dessous.
        const position = { x, y };
        let updatedStore = setEntityComponents(store, 'meiko', { position });

        // Et on retourne le store modifié
        return updatedStore;
    }

    // Cette fonction permet de modifier les composants d'une entité présente
    // au sein d'un store, sans modifier ce dernier directement : un nouveau
    // store est en fait retourné.
    function setEntityComponents(store, id, components) {
        return store.map((entity) => {
            if (entity.id !== id) {
                return entity;
            }
            // Je ne rentre par contre pas dans le détail de la syntaxe
            // JavaScript...
            return {
                ...entity,
                ...components,
            };
        });
    }
</script>

<style type="text/css">
    #app {
        --board-size: 6;
        --cell-size: 128px;

        --color-floor: #fff;
        --color-floor-border: #ccc;
    }

    * {
        box-sizing: border-box;
    }

    .board-line {
        display: flex;
    }

    .board-cell {
        width: var(--cell-size);
        height: var(--cell-size);

        background-color: var(--color-floor);
        border: 1px solid var(--color-floor-border);
    }

    .board {
        position: relative;
        /*
           On limite la largeur du tableau pour ne pas pouvoir cliquer en
           dehors de la zone de jeu. Ça aurait pu être fait plus tôt mais on
           s’en fichait un peu puisque ça ne posait pas encore de problème.
        */
        width: calc(var(--board-size) * var(--cell-size));
    }
    .board-cell-entity {
        position: absolute;
    }

    /*
       Rien de compliqué : .board-click-zone est positionné relativement à
       .board et le recouvre totalement, c'est donc bien lui qui va récupérer
       tous les clics. Oh, et on n'oublie pas le z-index pour nous assurer que
       ça passera par dessus les entités.
    */
    .board-click-zone {
        position: absolute;
        top: 0;
        bottom: 0;
        right: 0;
        left: 0;
        z-index: 100;
    }

    .board-cell-entity.oven { background-color: #333; }
    .board-cell-entity.fridge { background-color: #666; }
    .board-cell-entity.workplan { background-color: #783f04; }
    .board-cell-entity.shelf { background-color: #000; }
    .board-cell-entity.hatch { background-color: #cf2a27; }

    .board-cell-entity .entity-label { color: #fff; }
    .board-cell-entity.shelf .entity-label { text-align: right; }

    .board-cell-entity.dough,
    .board-cell-entity.mozza,
    .board-cell-entity.tomato {
        z-index: 10;

        background-color: green;
    }

    /* On s'assure que Meiko est toujours visible au-dessus des autres entités. */
    .board-cell-entity.meiko {
        z-index: 20;

        background-color: #fff;
        border: 2px solid green;
    }
    .board-cell-entity.meiko .entity-label {
        color: initial;
    }
</style>
